/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         master_parse
#define yylex           master_lex
#define yyerror         master_error
#define yydebug         master_debug
#define yynerrs         master_nerrs

#define yylval          master_lval
#define yychar          master_char

/* Copy the first part of user declarations.  */
#line 1 "master_parse.y" /* yacc.c:339  */

/* ----------------------------------------------------------------------- *
 *   
 *  master_parser.y - master map buffer parser.
 *
 *   Copyright 2006 Ian Kent <raven@themaw.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
 *   USA; either version 2 of the License, or (at your option) any later
 *   version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 * ----------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/ioctl.h>

#include "automount.h"
#include "master.h"

#define MAX_ERR_LEN	512
#define STRTYPE_LEN	2048

extern struct master *master_list;

char **add_argv(int, char **, char *);
const char **copy_argv(int, const char **);
int free_argv(int, const char **);

extern FILE *master_in;
extern char *master_text;
extern int master_lex(void);
extern int master_lineno;
extern void master_set_scan_buffer(const char *);

static char *master_strdup(char *);
static void local_init_vars(void);
static void local_free_vars(void);
static void trim_maptype(char *);
static int add_multi_mapstr(void);

static int master_error(const char *s);
static int master_notify(const char *s);
static int master_msg(const char *s);
 
static char *path;
static char *type;
static char *format;
static long timeout;
static long negative_timeout;
static long positive_timeout;
static unsigned symlnk;
static unsigned strictexpire;
static unsigned nobind;
static unsigned ghost;
extern unsigned global_selection_options;
static unsigned random_selection;
static unsigned use_weight;
static unsigned long mode;
static char **tmp_argv;
static int tmp_argc;
static char **local_argv;
static int local_argc;

#define PROPAGATION_SHARED	MOUNT_FLAG_SHARED
#define PROPAGATION_SLAVE	MOUNT_FLAG_SLAVE
#define PROPAGATION_PRIVATE	MOUNT_FLAG_PRIVATE
#define PROPAGATION_MASK	(MOUNT_FLAG_SHARED | \
				 MOUNT_FLAG_SLAVE  | \
				 MOUNT_FLAG_PRIVATE)
static unsigned int propagation;

static char errstr[MAX_ERR_LEN];
static int errlen;

static unsigned int verbose;
static unsigned int debug;

static int lineno;

#define YYDEBUG 0

#ifndef YYENABLE_NLS
#define YYENABLE_NLS 0
#endif
#ifndef YYLTYPE_IS_TRIVIAL
#define YYLTYPE_IS_TRIVIAL 0
#endif

#if YYDEBUG
static int master_fprintf(FILE *, char *, ...);
#undef YYFPRINTF
#define YYFPRINTF master_fprintf
#endif


#line 181 "master_parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "master_parse.tab.h".  */
#ifndef YY_MASTER_MASTER_PARSE_TAB_H_INCLUDED
# define YY_MASTER_MASTER_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int master_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    MAP = 259,
    OPT_TIMEOUT = 260,
    OPT_NTIMEOUT = 261,
    OPT_PTIMEOUT = 262,
    OPT_NOBIND = 263,
    OPT_NOGHOST = 264,
    OPT_GHOST = 265,
    OPT_VERBOSE = 266,
    OPT_DEBUG = 267,
    OPT_RANDOM = 268,
    OPT_USE_WEIGHT = 269,
    OPT_SYMLINK = 270,
    OPT_MODE = 271,
    OPT_STRICTEXPIRE = 272,
    OPT_SHARED = 273,
    OPT_SLAVE = 274,
    OPT_PRIVATE = 275,
    COLON = 276,
    COMMA = 277,
    NL = 278,
    DDASH = 279,
    PATH = 280,
    QUOTE = 281,
    NILL = 282,
    SPACE = 283,
    EQUAL = 284,
    MULTITYPE = 285,
    MAPTYPE = 286,
    DNSERVER = 287,
    DNATTR = 288,
    DNNAME = 289,
    MAPHOSTS = 290,
    MAPNULL = 291,
    MAPXFN = 292,
    MAPNAME = 293,
    NUMBER = 294,
    OCTALNUMBER = 295,
    OPTION = 296
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 108 "master_parse.y" /* yacc.c:355  */

	char strtype[2048];
	int inttype;
	long longtype;

#line 269 "master_parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE master_lval;

int master_parse (void);

#endif /* !YY_MASTER_MASTER_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 286 "master_parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   319

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  14
/* YYNRULES -- Number of rules.  */
#define YYNRULES  79
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  93

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   150,   150,   150,   158,   159,   169,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   237,
     246,   257,   265,   273,   288,   305,   315,   325,   335,   341,
     351,   368,   413,   451,   505,   510,   515,   521,   538,   557,
     562,   569,   584,   601,   606,   613,   614,   615,   616,   621,
     628,   629,   630,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   655
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "MAP", "OPT_TIMEOUT",
  "OPT_NTIMEOUT", "OPT_PTIMEOUT", "OPT_NOBIND", "OPT_NOGHOST", "OPT_GHOST",
  "OPT_VERBOSE", "OPT_DEBUG", "OPT_RANDOM", "OPT_USE_WEIGHT",
  "OPT_SYMLINK", "OPT_MODE", "OPT_STRICTEXPIRE", "OPT_SHARED", "OPT_SLAVE",
  "OPT_PRIVATE", "COLON", "COMMA", "NL", "DDASH", "PATH", "QUOTE", "NILL",
  "SPACE", "EQUAL", "MULTITYPE", "MAPTYPE", "DNSERVER", "DNATTR", "DNNAME",
  "MAPHOSTS", "MAPNULL", "MAPXFN", "MAPNAME", "NUMBER", "OCTALNUMBER",
  "OPTION", "$accept", "file", "$@1", "line", "mapspec", "maplist", "map",
  "dn", "dnattrs", "dnattr", "options", "option", "daemon_option",
  "mount_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296
};
# endif

#define YYPACT_NINF -40

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-40)))

#define YYTABLE_NINF -35

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -40,     6,    75,   -40,   -40,   261,   -40,   -40,   -40,   -40,
     -40,   -40,   -40,   -40,   -40,   -40,   -40,   -40,   -40,   -40,
     -40,   -40,   -40,   -40,   -40,   -40,   -40,   109,     0,     1,
     -40,   -40,   -40,   -40,   -40,   -40,   -40,   187,   -40,     5,
     113,   -40,   -29,   -40,   -40,   -40,    26,   -40,    -4,    -3,
      23,   -40,   -40,   -40,   -40,   -40,   -40,   -40,   -40,    24,
     -40,   -40,   -40,   -40,   -40,    76,   -40,   -40,   -40,   109,
       2,   -40,    43,   -40,   -40,   -40,   -40,   207,   -40,   -40,
     150,    -6,   244,   -40,    39,    37,   -40,   -40,   -40,    33,
      47,    -6,   -40
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     4,     1,    28,    24,    25,    27,    26,     3,
      13,    19,    21,    20,    22,    12,    10,    11,    14,    23,
      15,    16,    17,    18,     7,    35,     9,     0,    46,    50,
      49,    37,    39,    38,    36,     8,     5,     0,    40,     6,
       0,    41,     0,    42,    43,    45,     0,    62,     0,     0,
       0,    71,    72,    73,    74,    75,    76,    77,    66,     0,
      67,    68,    69,    70,    79,     0,    55,    60,    61,     0,
       0,    44,    47,    63,    64,    65,    78,     0,    59,    57,
       0,     0,     0,    56,     0,    53,    54,    48,    58,     0,
      51,     0,    52
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -40,   -40,   -40,   -40,   -40,   -40,   -27,   -40,    -5,   -21,
     -39,   235,   -40,   -40
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,     9,    36,    39,    37,    44,    38,    87,
      65,    66,    67,    68
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      40,    70,   -32,    47,    29,    30,     3,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    45,    77,    41,   -32,    85,    86,    69,
      46,    78,    42,    29,    30,    73,    74,    71,    43,   -34,
      47,    84,    80,    64,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      72,    77,    75,   -34,    76,    81,    89,    90,    78,    91,
      92,     0,     0,     0,     0,     0,   -30,    47,     4,     0,
      64,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,     0,    77,     0,
       5,     6,     7,     0,     0,    78,     0,     0,     0,     0,
       0,     0,     0,   -31,    47,     0,     8,    64,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    25,     0,     0,   -31,     0,     0,
      28,     0,    29,    30,    31,    32,    33,    34,     0,     0,
     -33,    47,     0,     0,    64,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,     0,     0,     0,   -33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -29,    47,     0,
       0,    64,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    47,     0,
       0,     0,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    47,     0,     0,    64,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,     0,    10,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,     0,     0,    64,    25,     0,    26,     0,
       0,    27,    28,     0,    29,    30,    31,    32,    33,    34,
      79,     0,    35,     0,     0,    79,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,    88,     0,    79
};

static const yytype_int8 yycheck[] =
{
      27,    40,     0,     1,    33,    34,     0,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    28,    22,    25,    24,    33,    34,    24,
      29,    29,    32,    33,    34,    39,    39,    42,    38,     0,
       1,    80,    69,    41,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      34,    22,    39,    24,    40,    22,    29,    34,    29,    22,
      91,    -1,    -1,    -1,    -1,    -1,     0,     1,     3,    -1,
      41,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    -1,
      25,    26,    27,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,     1,    -1,    41,    41,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    25,    -1,    -1,    24,    -1,    -1,
      31,    -1,    33,    34,    35,    36,    37,    38,    -1,    -1,
       0,     1,    -1,    -1,    41,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,
      -1,    41,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    41,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    41,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,     5,    -1,    -1,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    41,    25,    -1,    27,    -1,
      -1,    30,    31,    -1,    33,    34,    35,    36,    37,    38,
      65,    -1,    41,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    82,    -1,    84
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    43,    44,     0,     3,    25,    26,    27,    41,    45,
       5,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    25,    27,    30,    31,    33,
      34,    35,    36,    37,    38,    41,    46,    48,    50,    47,
      48,    25,    32,    38,    49,    50,    29,     1,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    41,    52,    53,    54,    55,    24,
      52,    50,    34,    39,    39,    39,    40,    22,    29,    53,
      48,    22,    22,    53,    52,    33,    34,    51,    53,    29,
      34,    22,    51
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    42,    44,    43,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    45,    45,    46,
      46,    47,    47,    47,    47,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    49,    49,    49,    50,    50,    50,
      50,    51,    51,    51,    51,    52,    52,    52,    52,    52,
      53,    53,    53,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    55
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     0,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     3,     4,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     1,     0,     3,     5,     1,
       1,     3,     5,     1,     1,     1,     3,     2,     4,     2,
       1,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 150 "master_parse.y" /* yacc.c:1646  */
    {
		master_lineno = 0;
#if YYDEBUG != 0
		master_debug = YYDEBUG;
#endif
	}
#line 1484 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 160 "master_parse.y" /* yacc.c:1646  */
    {
		if (path)
			free(path);
		path = master_strdup((yyvsp[-1].strtype));
		if (!path) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1498 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 170 "master_parse.y" /* yacc.c:1646  */
    {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if (path)
			free(path);
		path = master_strdup((yyvsp[-2].strtype));
		if (!path) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';
#ifndef WITH_HESIOD
		/* Map type or map type parser is hesiod */
		if (!strcmp((yyvsp[-1].strtype), "hesiod") || (tmp && !strcmp(tmp, "hesiod"))) {
			master_error("hesiod support not built in");
			local_free_vars();
			YYABORT;
		}
#endif
		if (type)
			free(type);
		type = master_strdup((yyvsp[-1].strtype));
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			if (format)
				free(format);
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
	}
#line 1546 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 213 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1552 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 214 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1558 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 215 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1564 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 216 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1570 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 217 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1576 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 218 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1582 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 219 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1588 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 220 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1594 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 221 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1600 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 222 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1606 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 223 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1612 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 224 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1618 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 225 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1624 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 226 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1630 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 227 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1636 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 228 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1642 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 229 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[-1].strtype)); YYABORT; }
#line 1648 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 230 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1654 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 231 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1660 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 232 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1666 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 233 "master_parse.y" /* yacc.c:1646  */
    { master_notify((yyvsp[0].strtype)); YYABORT; }
#line 1672 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 234 "master_parse.y" /* yacc.c:1646  */
    { YYABORT; }
#line 1678 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 238 "master_parse.y" /* yacc.c:1646  */
    {
		if (local_argv)
			free_argv(local_argc, (const char **) local_argv);
		local_argc = tmp_argc;
		local_argv = tmp_argv;
		tmp_argc = 0;
		tmp_argv = NULL;
	}
#line 1691 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 247 "master_parse.y" /* yacc.c:1646  */
    {
		if (local_argv)
			free_argv(local_argc, (const char **) local_argv);
		local_argc = tmp_argc;
		local_argv = tmp_argv;
		tmp_argc = 0;
		tmp_argv = NULL;
	}
#line 1704 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 258 "master_parse.y" /* yacc.c:1646  */
    {
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1716 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 266 "master_parse.y" /* yacc.c:1646  */
    {
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1728 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 274 "master_parse.y" /* yacc.c:1646  */
    {
		local_argc++;
		local_argv = add_argv(local_argc, local_argv, "--");
		if (!local_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1747 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 289 "master_parse.y" /* yacc.c:1646  */
    {
		local_argc++;
		local_argv = add_argv(local_argc, local_argv, "--");
		if (!local_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (!add_multi_mapstr()) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1766 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 306 "master_parse.y" /* yacc.c:1646  */
    {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1780 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 316 "master_parse.y" /* yacc.c:1646  */
    {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1794 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 326 "master_parse.y" /* yacc.c:1646  */
    {
		if (type)
			free(type);
		type = master_strdup((yyvsp[0].strtype) + 1);
		if (!type) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1808 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 336 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[0].strtype));
		master_msg("X/Open Federated Naming service not supported");
		YYABORT;
	}
#line 1818 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 342 "master_parse.y" /* yacc.c:1646  */
    {
		if (type)
			free(type);
		type = master_strdup((yyvsp[0].strtype) + 1);
		if (!type) {
			local_free_vars();
			YYABORT;
		}
	}
#line 1832 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 352 "master_parse.y" /* yacc.c:1646  */
    {
		if (type)
			free(type);
		type = master_strdup("ldap");
		if (!type) {
			local_free_vars();
			YYABORT;
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1853 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 369 "master_parse.y" /* yacc.c:1646  */
    {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';
#ifndef WITH_HESIOD
		/* Map type or map type parser is hesiod */
		if (!strcmp((yyvsp[-1].strtype), "hesiod") || (tmp && !strcmp(tmp, "hesiod"))) {
			master_error("hesiod support not built in");
			local_free_vars();
			YYABORT;
		}
#endif
		if (type)
			free(type);
		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			if (format)
				free(format);
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1902 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 414 "master_parse.y" /* yacc.c:1646  */
    {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		if (type)
			free(type);
		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			if (format)
				free(format);
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 1944 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 452 "master_parse.y" /* yacc.c:1646  */
    {
		char *tmp = NULL;

		trim_maptype((yyvsp[-1].strtype));

		if ((tmp = strchr((yyvsp[-1].strtype), ',')))
			*tmp++ = '\0';

		if (type)
			free(type);
		if (strcmp((yyvsp[-1].strtype), "exec"))
			type = master_strdup((yyvsp[-1].strtype));
		else
			type = master_strdup("program");
		if (!type) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		if (tmp) {
			if (format)
				free(format);
			format = master_strdup(tmp);
			if (!format) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
		}
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
		/* Add back the type for lookup_ldap.c to handle ldaps */
		if (*tmp_argv[0]) {
			tmp = malloc(strlen(type) + strlen(tmp_argv[0]) + 2);
			if (!tmp) {
				master_error("memory allocation error");
				local_free_vars();
				YYABORT;
			}
			strcpy(tmp, type);
			strcat(tmp, ":");
			strcat(tmp, tmp_argv[0]);
			free(tmp_argv[0]);
			tmp_argv[0] = tmp;
		}
	}
#line 2000 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 506 "master_parse.y" /* yacc.c:1646  */
    {
		strcpy((yyval.strtype), (yyvsp[-1].strtype));
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2009 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 511 "master_parse.y" /* yacc.c:1646  */
    {
		strcpy((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2017 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 515 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify("syntax error in dn");
		YYABORT;
	}
#line 2026 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 522 "master_parse.y" /* yacc.c:1646  */
    {
		if (strcasecmp((yyvsp[-2].strtype), "cn") &&
		    strcasecmp((yyvsp[-2].strtype), "ou") &&
		    strcasecmp((yyvsp[-2].strtype), "automountMapName") &&
		    strcasecmp((yyvsp[-2].strtype), "nisMapName")) {
			errlen = snprintf(errstr, MAX_ERR_LEN, "%s=%s", (yyvsp[-2].strtype), (yyvsp[0].strtype));
			if (errlen < MAX_ERR_LEN)
				master_notify(errstr);
			else
				master_notify("error string too long");
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2047 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 539 "master_parse.y" /* yacc.c:1646  */
    {
		if (strcasecmp((yyvsp[-4].strtype), "cn") &&
		    strcasecmp((yyvsp[-4].strtype), "ou") &&
		    strcasecmp((yyvsp[-4].strtype), "automountMapName") &&
		    strcasecmp((yyvsp[-4].strtype), "nisMapName")) {
			errlen = snprintf(errstr, MAX_ERR_LEN, "%s=%s", (yyvsp[-4].strtype), (yyvsp[-2].strtype));
			if (errlen < MAX_ERR_LEN)
				master_notify(errstr);
			else
				master_notify("error string too long");
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-4].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), ",");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2070 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 558 "master_parse.y" /* yacc.c:1646  */
    {
		/* Matches map in old style syntax ldap:server:map */
		strcpy((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2079 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 563 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 2088 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 570 "master_parse.y" /* yacc.c:1646  */
    {
		if (!strcasecmp((yyvsp[-2].strtype), "automountMapName") ||
		    !strcasecmp((yyvsp[-2].strtype), "nisMapName")) {
			errlen = snprintf(errstr, MAX_ERR_LEN, "%s=%s", (yyvsp[-2].strtype), (yyvsp[0].strtype));
			if (errlen < MAX_ERR_LEN)
				master_notify(errstr);
			else
				master_notify("error string too long");
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2107 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 585 "master_parse.y" /* yacc.c:1646  */
    {
		if (!strcasecmp((yyvsp[-4].strtype), "automountMapName") ||
		    !strcasecmp((yyvsp[-4].strtype), "nisMapName")) {
			errlen = snprintf(errstr, MAX_ERR_LEN, "%s=%s", (yyvsp[-4].strtype), (yyvsp[-2].strtype));
			if (errlen < MAX_ERR_LEN)
				master_notify(errstr);
			else
				master_notify("error string too long");
			YYABORT;
		}
		strcpy((yyval.strtype), (yyvsp[-4].strtype));
		strcat((yyval.strtype), "=");
		strcat((yyval.strtype), (yyvsp[-2].strtype));
		strcat((yyval.strtype), ",");
		strcat((yyval.strtype), (yyvsp[0].strtype));
	}
#line 2128 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 602 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 2137 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 607 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 2146 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 613 "master_parse.y" /* yacc.c:1646  */
    {}
#line 2152 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 614 "master_parse.y" /* yacc.c:1646  */
    {}
#line 2158 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 615 "master_parse.y" /* yacc.c:1646  */
    {}
#line 2164 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 617 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[-3].strtype));
		YYABORT;
	}
#line 2173 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 622 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify((yyvsp[-1].strtype));
		YYABORT;
	}
#line 2182 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 629 "master_parse.y" /* yacc.c:1646  */
    {}
#line 2188 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 631 "master_parse.y" /* yacc.c:1646  */
    {
		master_notify("bogus option");
		YYABORT;
	}
#line 2197 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 637 "master_parse.y" /* yacc.c:1646  */
    { timeout = (yyvsp[0].longtype); }
#line 2203 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 638 "master_parse.y" /* yacc.c:1646  */
    { negative_timeout = (yyvsp[0].longtype); }
#line 2209 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 639 "master_parse.y" /* yacc.c:1646  */
    { positive_timeout = (yyvsp[0].longtype); }
#line 2215 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 640 "master_parse.y" /* yacc.c:1646  */
    { symlnk = 1; }
#line 2221 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 641 "master_parse.y" /* yacc.c:1646  */
    { strictexpire = 1; }
#line 2227 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 642 "master_parse.y" /* yacc.c:1646  */
    { propagation = PROPAGATION_SHARED; }
#line 2233 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 643 "master_parse.y" /* yacc.c:1646  */
    { propagation = PROPAGATION_SLAVE; }
#line 2239 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 644 "master_parse.y" /* yacc.c:1646  */
    { propagation = PROPAGATION_PRIVATE; }
#line 2245 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 645 "master_parse.y" /* yacc.c:1646  */
    { nobind = 1; }
#line 2251 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 646 "master_parse.y" /* yacc.c:1646  */
    { ghost = 0; }
#line 2257 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 647 "master_parse.y" /* yacc.c:1646  */
    { ghost = 1; }
#line 2263 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 648 "master_parse.y" /* yacc.c:1646  */
    { verbose = 1; }
#line 2269 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 649 "master_parse.y" /* yacc.c:1646  */
    { debug = 1; }
#line 2275 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 650 "master_parse.y" /* yacc.c:1646  */
    { random_selection = 1; }
#line 2281 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 651 "master_parse.y" /* yacc.c:1646  */
    { use_weight = 1; }
#line 2287 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 652 "master_parse.y" /* yacc.c:1646  */
    { mode = (yyvsp[0].longtype); }
#line 2293 "master_parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 656 "master_parse.y" /* yacc.c:1646  */
    {
		tmp_argc++;
		tmp_argv = add_argv(tmp_argc, tmp_argv, (yyvsp[0].strtype));
		if (!tmp_argv) {
			master_error("memory allocation error");
			local_free_vars();
			YYABORT;
		}
	}
#line 2307 "master_parse.tab.c" /* yacc.c:1646  */
    break;


#line 2311 "master_parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 666 "master_parse.y" /* yacc.c:1906  */


#if YYDEBUG
static int master_fprintf(FILE *f, char *msg, ...)
{
	va_list ap;
	va_start(ap, msg);
	vsyslog(LOG_DEBUG, msg, ap);
	va_end(ap);
	return 1;
}
#endif

static char *master_strdup(char *str)
{
	char *tmp;

	tmp = strdup(str);
	if (!tmp)
		master_error("memory allocation error");
	return tmp;
}

static int master_error(const char *s)
{
	logmsg("%s while parsing map.", s);
	return 0;
}

static int master_notify(const char *s)
{
	logmsg("syntax error in map near [ %s ]", s);
	return(0);
}

static int master_msg(const char *s)
{
	logmsg("%s", s);
	return 0;
}

static void local_init_vars(void)
{
	path = NULL;
	type = NULL;
	format = NULL;
	verbose = 0;
	debug = 0;
	timeout = -1;
	negative_timeout = 0;
	symlnk = 0;
	strictexpire = 0;
	propagation = PROPAGATION_SLAVE;
	nobind = 0;
	ghost = defaults_get_browse_mode();
	random_selection = global_selection_options & MOUNT_FLAG_RANDOM_SELECT;
	use_weight = 0;
	mode = 0;
	tmp_argv = NULL;
	tmp_argc = 0;
	local_argv = NULL;
	local_argc = 0;
}

static void local_free_vars(void)
{
	if (path)
		free(path);

	if (type)
		free(type);

	if (format)
		free(format);

	if (local_argv) {
		free_argv(local_argc, (const char **) local_argv);
		local_argv = NULL;
		local_argc = 0;
	}

	if (tmp_argv) {
		free_argv(tmp_argc, (const char **) tmp_argv);
		tmp_argv = NULL;
		tmp_argc = 0;
	}
}

static void trim_maptype(char *type)
{
	char *tmp;

	tmp = strchr(type, ':');
	if (tmp)
		*tmp = '\0';
	else {
		int len = strlen(type);
		while (len-- && isblank(type[len]))
			type[len] = '\0';
	}
	return;
}

static int add_multi_mapstr(void)
{
	if (type) {
		/* If type given and format is non-null add it back */
		if (format) {
			int len = strlen(type) + strlen(format) + 2;
			char *tmp = realloc(type, len);
			if (!tmp)
				return 0;
			type = tmp;
			strcat(type, ",");
			strcat(type, format);
			free(format);
			format = NULL;
		}

		local_argc++;
		local_argv = add_argv(local_argc, local_argv, type);
		if (!local_argv) {
			free(type);
			type = NULL;
			return 0;
		}

		free(type);
		type = NULL;
	}

	local_argv = append_argv(local_argc, local_argv, tmp_argc, tmp_argv);
	if (!local_argv) {
		free(type);
		type = NULL;
		return 0;
	}
	local_argc += tmp_argc;

	tmp_argc = 0;
	tmp_argv = NULL;

	return 1;
}

void master_init_scan(void)
{
	lineno = 0;
}

int master_parse_entry(const char *buffer, unsigned int default_timeout, unsigned int logging, time_t age)
{
	struct master *master = master_list;
	struct mapent_cache *nc;
	struct master_mapent *entry, *new;
	struct map_source *source;
	unsigned int logopt = logging;
	unsigned int m_logopt = master->logopt;
	size_t mp_len;
	int ret;

	local_init_vars();

	lineno++;

	master_set_scan_buffer(buffer);

	ret = master_parse();
	if (ret != 0) {
		local_free_vars();
		return 0;
	}

	mp_len = strlen(path);
	while (mp_len && path[--mp_len] == '/')
		path[mp_len] = 0;

	nc = master->nc;

	/* Add null map entries to the null map cache */
	if (type && !strcmp(type, "null")) {
		cache_update(nc, NULL, path, NULL, lineno);
		local_free_vars();
		return 1;
	}

	/* Ignore all subsequent matching nulled entries */
	if (cache_lookup_distinct(nc, path)) {
		local_free_vars();
		return 1;
	}

	if (debug || verbose) {
		logopt = (debug ? LOGOPT_DEBUG : 0);
		logopt |= (verbose ? LOGOPT_VERBOSE : 0);
	}

	new = NULL;
	entry = master_find_mapent(master, path);
	if (!entry) {
		new = master_new_mapent(master, path, age);
		if (!new) {
			local_free_vars();
			return 0;
		}
		entry = new;
	} else {
		if (entry->age && entry->age == age) {
			if (strcmp(path, "/-")) {
				info(m_logopt,
				    "ignoring duplicate indirect mount %s",
				     path);
				local_free_vars();
				return 0;
			}
		}
	}

	if (!format) {
		if (conf_amd_mount_section_exists(path))
			format = strdup("amd");
	}

	if (format && !strcmp(format, "amd")) {
		unsigned int loglevel = conf_amd_get_log_options();
		unsigned int flags = conf_amd_get_flags(path);

		if (loglevel <= LOG_DEBUG && loglevel > LOG_INFO)
			logopt = LOGOPT_DEBUG;
		else if (loglevel <= LOG_INFO && loglevel > LOG_ERR)
			logopt = LOGOPT_VERBOSE;

		/* It isn't possible to provide the fullybrowsable amd
		 * browsing functionality within the autofs framework.
		 * This flag will not be set if browsable_dirs = full
		 * in the configuration or fullybrowsable is present as
		 * an option.
		 */
		if (flags & CONF_BROWSABLE_DIRS)
			ghost = 1;
	}

	if (!entry->ap) {
		ret = master_add_autofs_point(entry, logopt, nobind, ghost, 0);
		if (!ret) {
			error(m_logopt, "failed to add autofs_point");
			if (new)
				master_free_mapent(new);
			local_free_vars();
			return 0;
		}
	}
	entry->ap->flags &= ~(PROPAGATION_MASK);
	entry->ap->flags |= propagation;

	if (random_selection)
		entry->ap->flags |= MOUNT_FLAG_RANDOM_SELECT;
	if (use_weight)
		entry->ap->flags |= MOUNT_FLAG_USE_WEIGHT_ONLY;
	if (symlnk)
		entry->ap->flags |= MOUNT_FLAG_SYMLINK;
	if (strictexpire)
		entry->ap->flags |= MOUNT_FLAG_STRICTEXPIRE;
	if (negative_timeout)
		entry->ap->negative_timeout = negative_timeout;
	if (mode && mode < LONG_MAX)
		entry->ap->mode = mode;

	if (timeout < 0) {
		/*
		 * If no timeout is given get the timout from the
		 * autofs point, or the first map, or the config
		 * for amd maps.
		 */
		if (format && !strcmp(format, "amd"))
			timeout = conf_amd_get_dismount_interval(path);
		else
			timeout = get_exp_timeout(entry->ap, entry->maps);
	}

	if (format && !strcmp(format, "amd")) {
		char *opts = conf_amd_get_map_options(path);
		if (opts) {
			/* autofs uses the equivalent of cache:=inc,sync
			 * (except for file maps which use cache:=all,sync)
			 * but if the map is large then it may be necessary
			 * to read the whole map at startup even if browsing
			 * is is not enabled, so look for cache:=all in the
			 * map_options configuration entry.
			 */
			if (strstr(opts, "cache:=all"))
				entry->ap->flags |= MOUNT_FLAG_AMD_CACHE_ALL;
			free(opts);
		}
	}

/*
	source = master_find_map_source(entry, type, format,
					local_argc, (const char **) local_argv); 
	if (!source)
		source = master_add_map_source(entry, type, format, age, 
					local_argc, (const char **) local_argv);
	else
		source->age = age;
*/
	source = master_add_map_source(entry, type, format, age, 
					local_argc, (const char **) local_argv);
	if (!source) {
		error(m_logopt, "failed to add source");
		if (new)
			master_free_mapent(new);
		local_free_vars();
		return 0;
	}
	set_exp_timeout(entry->ap, source, timeout);
	source->master_line = lineno;

	entry->age = age;
	entry->current = NULL;

	if (new)
		master_add_mapent(master, entry);

	local_free_vars();

	return 1;
}

